#pragma once
#include<string>
#include<set>  
#include "CivInp.h"

class  CivDbConnection;

/**
* ˮ
*/
class  CivHydrCalc
{
public:
	CivHydrCalc(char* uri, std::string netName);
	~CivHydrCalc();

	/**
	 *@brief ˮģ
	 *@inpFile:inpļ
	 *@rptFile: ļ
	 *@binOutFile: ļ
	 */
	bool hydrSimulation(char* inpFile, char* rptFile, char* binOutFile);

	/**
	 *@brief ˮģ
	 *@inpFile:inpļ
	 *@rptFile: ļ
	 *@binOutFile: ļ
	 */
	bool qualitySimulation(char* inpFile, char* rptFile, char* binOutFile);

	bool getDataByInterval( char* date, char* interval);

	/**
	*@brief inpļ
	*/
	bool exportInp(char* fileName);

private:
	/**
	*@brief ֶ˳д
	*@table:
	*@inp: inpļ
	*/
	void assemble(const std::string& table, CivInp& inp);

	bool hydrCompute(int& errorcode);
	/*
	*@brief ȡڵ
	*@time ʱ
	*/
	void getNodeResult(short time);

	/*
	*@brief ȡ߼
	*@time ʱ
	*/
	void getLinkResult(short time);

	/**
	*@brief ȡй̲Ĵ
	*/
	std::string getLastError() { return mLastError; }

private:
	CivDbConnection* mDbConn;
	std::string mNetname;
	std::string mLastError;
};


