#ifndef CIVDBCONN_H
#define CIVDBCONN
#include "CivTypes.h"
#include "CivTableTemp.h"


/**
   ݿӽӿ
*/
class CivDbConn
{
public:
	CivDbConn();
	virtual ~CivDbConn();

	/**
	*@brief ݿ⣬йʵ
	*/
	virtual bool open() = 0;

	/**
	*@brief رݿӣйʵ
	*/
	virtual void close() = 0;
	/**
	 *@brief ȡбݿأʵ
	 *@netName: 
	 */
	virtual Tables getTables(StrQuote netName, StrQuote schema) = 0;

	/**
	*@brief жĳűǷڣжϷݿйأӳٵʵ
	*@tableName: 
	*/
	virtual bool tableExist(StrQuote tableName) = 0;

	/**
	 *@brief 
	 *@tableName: 
	 *@schema:
	 *@tableType߽ͣ
	 */
	bool createTable(StrQuote tableName, StrQuote schema, CivTableTemp::TableType tableType);

	/**
	 *@brief ȡݣߣڵ㣬ˮԴȣ
	 *@tableName 
	 */
	Componets getComponets(StrQuote tableName);

	Componets getComponetsByWhere(StrQuote tableName, StrQuote where);

	/**
	 *@brief  ˮã (ڵתΪ)
	 *@tableName 
	 */
	Componets getLikelyPipes(StrQuote tableName);

	/**
	*@brief ֵֶɾ
	*@table
	*@filedNameֶ
	*@fieldValueֵֶ
	*/
	bool deleteByField(StrQuote table, StrQuote filedName, StrQuote fieldValue);

	bool updateNodeByInterval(StrQuote currDate, StrQuote interval);

	bool updateLinkByInterval(StrQuote currDate, StrQuote interval);
	/**
	 *@brief µ
	 *@nodeItemsҪµֵ
	 */
	bool updateNode(const NodeResultItems& nodeItems);

	/**
	 *@brief ߱
	 *@lineItems: 
	 */
	bool updateLink(const LinkResultItems& lineItems);

	// ӹֵֶ
	void addFilter(Str type, Str number);

	// ȡ˼
	FiledFilter getFilter() const;

	// ȡǰִдϢ
	Str getLastError() const;


	bool isValid() const;
private:
	/**
	 *@brief codeֵѰ
	 *@table: ߱
	 *@code: code
	 */
	Componets getValueByCode(StrQuote table, StrQuote code);

	/**
	 *@brief ִsql
	 *@sql: Ҫִеsql
	 */
	virtual bool execSql(Str sql) = 0;

	/**
	*@brief ѯ
	*/
	virtual void clearResult() = 0;

	/**
	 *@brief Ӳѯȡ
	 *@result: ѯ
	 *@comp: 
	 */
	virtual void getData(Componets& comp) = 0;

protected:
	bool mIsOpen = false; // ݿϢ
	char* mLastError; // ִsqlĴϢ

private:	
	FiledFilter mFilter; // :Ӧı
};


#endif // !CIVDBCONN_H

