#ifndef CIVTABLETEMP_H
#define CIVTABLETEMP_H

#include<string>
#include<vector>
#include<map>

#include "CivTypes.h"

typedef struct FieldProperty
{
	std::string mFiledName; //ֶ
	std::string mFieldType; // ֶ
};

#define FiledPropertys std::vector<FieldProperty>

/**
*  ݿģ
*/
class CivTableTemp
{
public:

	// 
	enum TableType
	{
		NODE_TABLE, // 
		PIPE_TABLE, // ߱
		PATTERN_TABLE, // ģʽ
		CURVE_TABLE, //߱
		PARAMETER_TABLE // 
	};

	// ֶ
	enum FieldType {
		FILED_INT,
		FILED_INTEGER,
		FILED_DOUBLE,
		FILED_VARCHAR,
		FILED_VARCHAR64,
		FILED_VARCHAR128,
		FILED_DATETIME,
		FILED_JSON,
		FILED_DATE
	};

	explicit CivTableTemp(Str tableName, TableType tableType);

	~CivTableTemp();

	/**
	*@brief ֶ
	*@fileNameֶ
	*@filedTypeֶ
	*/
	void addProperty(std::string fileName, FieldType filedType);

	// ֶ
	void addPropertys(FiledPropertys props);

	// شsql
	Str createSql();

private:
	Str mTableName; // 
	TableType mTableType; // 

	FiledPropertys mPropertys; // ֶκֶ
	std::map< FieldType, Str> mFieldTyepMap;
};

#endif // !CIVTABLETEMP_H



